//
//  AppDelegate.m
//  YiXinSDKSample
//
//  Version 1.2
//  Created by yixin ( yixinopen@188.com )
//  Copyright (c) 2013年 yixin.im All rights reserved.
//

#import "AppDelegate.h"

#define AppKey @"yxbbd0e8b3dce64e02bab42437becc4384" // url scheme 参数
//#define AppKey @"ga244850d3d9ef445db291dfc2e68666a8"    //测试游戏用的URL SCHEME....

@implementation AppDelegate

- (void)dealloc
{
    [_window release];
    [_viewController release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    
    [YXApi registerApp:AppKey];
    
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    self.viewController = [[[TestViewController alloc] initWithNibName:@"TestViewController" bundle:nil] autorelease];
    [self.viewController setDelegate:self];
    self.window.rootViewController = self.viewController;
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

#pragma mark -
#pragma mark - YixinAPI use
- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url
{
    return  [YXApi handleOpenURL:url delegate:self];
}

- (BOOL)application:(UIApplication *)application openURL:(NSURL *)url sourceApplication:(NSString *)sourceApplication annotation:(id)annotation
{
    return  [YXApi handleOpenURL:url delegate:self];
}

#pragma mark -
#pragma mark - YXApiDelegate method
- (void)onReceiveRequest: (YXBaseReq *)req {
    if ([req isKindOfClass:[ShowMessageFromYXReq class]]) {
        ShowMessageFromYXReq* reciveReq = (ShowMessageFromYXReq*)req;
        if(reciveReq.message != nil && [reciveReq.message.mediaObject isKindOfClass:[YXAppExtendObject class]]){
            YXAppExtendObject* msg = (YXAppExtendObject*)reciveReq.message.mediaObject;
            [self showAlert:[NSString stringWithFormat:@"url:%@\nextendinfo:%@", msg.url, msg.extInfo]];
        }
        NSLog(@"%ld", (long)reciveReq.type);
    }
    
}

- (void)onReceiveResponse: (YXBaseResp *)resp {
    if([resp isKindOfClass:[SendMessageToYXResp class]])
    {
        SendMessageToYXResp *sendResp = (SendMessageToYXResp *)resp;
        NSLog(@"%ld, %@", (long)sendResp.code, sendResp.errDescription);
    }
}

#pragma mark -
#pragma mark - YXViewDelegate method

// 分享 纯文本信息
- (void)sendTextContent
{
    SendMessageToYXReq *req = [[SendMessageToYXReq alloc] init];
    req.bText = YES;
    req.text = @"http://img5.cache.netease.com/photo/ 童鞋，我想跟你说个事呀！童鞋，童鞋，我想跟你说个事呀！";
    req.scene = _curScene;
    
    [YXApi sendReq:req];
    [req release];
    //    BOOL result = [YXApi sendReq:req];// 返回校验结果
    //    if(!result){
    //        [self showAlert:@"数据校验有误，请重新检查后 分享"];
    //    }
    //    [req release];
    
}

// 分享 图片Image
// [imageUrl | imageData] 参数不能同时为空
- (void)sendImageContent
{
    NSData *imageData = nil;
    NSString *filePath = [[NSBundle mainBundle] pathForResource:@"image_3" ofType:@"jpg"];
    imageData = [NSData dataWithContentsOfFile:filePath];
    
    YXImageObject *imageObject = [YXImageObject object];
    imageObject.imageUrl = @"http://img5.cache.netease.com/photo/0001/2013-08-30/97IESEHO19BR0001.jpg";
    imageObject.imageData = imageData;  //[imageUrl | imageData] 参数不能同时为空
    
    YXMediaMessage *message = [YXMediaMessage message];
    //imageObject.imageData 为空时，thumbData 图片尺寸必须不小于200*200
    NSData *thumImageData = UIImageJPEGRepresentation([UIImage imageNamed:@"image_2.jpg"], 1.f);
    [message setThumbData:thumImageData];
    message.mediaObject = imageObject;
    
    SendMessageToYXReq *req = [[SendMessageToYXReq alloc] init];
    req.bText = NO;
    req.scene = _curScene;
    req.message = message;
    
    [YXApi sendReq:req];
    [req release];
    //    BOOL result = [YXApi sendReq:req];// 返回校验结果
    //    if(!result){
    //         [self showAlert:@"数据校验有误，请重新检查后 分享"];
    //    }
    //    [req release];
}

// 分享 音乐music
// [musicUrl | musicDataUrl | musicLowBandDataUrl | musicLowBandUrl] 参数不能同时为空
- (void)sendMusicContent
{
    YXMusicObject *musicObject = [YXMusicObject object];
    musicObject.musicUrl = @"http://music.163.com/#/m/playlist?id=351643";
    musicObject.musicDataUrl = @"http://m1.music.126.net/9wQFXYxsK6RGXlNJCsYPHA==/2101166720692146.mp3";
    musicObject.musicLowBandDataUrl = @"http://m1.music.126.net/9wQFXYxsK6RGXlNJCsYPHA==/2101166720692146.mp3";//低音质 音乐链接，用于网络较差情况
    musicObject.musicLowBandUrl = @"http://music.163.com/#/m/playlist?id=351643";
    
    YXMediaMessage *message = [YXMediaMessage message];
    message.title = @"一曲民谣暖意生";
    message.msgDescription = @"欧美音乐频道";
    
    NSData *thumImageData = UIImageJPEGRepresentation([UIImage imageNamed:@"image_1.png"], 1.f);
    [message setThumbData:thumImageData];
    message.mediaObject = musicObject;
    
    SendMessageToYXReq *req = [[SendMessageToYXReq alloc] init];
    req.bText = NO;
    req.scene = _curScene;
    req.message = message;
    req.comment = @"hey man";
    
    [YXApi sendReq:req];
    [req release];
    //    BOOL result = [YXApi sendReq:req];// 返回校验结果
    //    if(!result){
    //        [self showAlert:@"数据校验有误，请重新检查后 分享"];
    //    }
    //    [req release];
}

// 分享 链接webPage
// [webpageUrl] 参数不能为空
- (void)sendWebPageContent
{
    YXWebpageObject *pageObject = [YXWebpageObject object];
    pageObject.webpageUrl = @"http://www.163.com";
    
    YXMediaMessage *message = [YXMediaMessage message];
    message.title = @"网易 有态度";
    message.msgDescription = @"网易是中国领先的互联网技术公司，为用户提供免费邮箱、游戏、搜索引擎服务，开设新闻、娱乐、体育等30多个内容频道，及博客、视频、论坛等互动交流，网聚人的力量。";
    
    NSData *thumImageData = UIImageJPEGRepresentation([UIImage imageNamed:@"image_2.jpg"], 1.f);
    [message setThumbData:thumImageData];
    message.mediaObject = pageObject;
    
    SendMessageToYXReq *req = [[SendMessageToYXReq alloc] init];
    req.bText = NO;
    req.scene = _curScene;
    req.message = message;
    
    [YXApi sendReq:req];
    [req release];
    //    BOOL result = [YXApi sendReq:req];// 返回校验结果
    //    if(!result){
    //        [self showAlert:@"数据校验有误，请重新检查后 分享"];
    //    }
    //    [req release];
}

// 分享 视频video
// [videoLowBandUrl | videoUrl] 参数不能同时为空
- (void)sendVideoContent
{
    YXVideoObject *videoObject = [YXVideoObject object];
    videoObject.videoLowBandUrl =  @"http://218.59.144.96/mov.bn.netease.com/mobilev/2012/12/7/Q/S8I5E4D7Q.mp4?wsiphost=ipdbm";//低品质视频，用于网络较差情况
    videoObject.videoUrl = @"http://218.59.144.96/mov.bn.netease.com/mobilev/2012/12/7/Q/S8I5E4D7Q.mp4?wsiphost=ipdbm";
    
    YXMediaMessage *message = [YXMediaMessage message];
    message.title = @"斯坦福大学公开课：量子力学> 量子比特实验与狄拉克符号 ";
    message.msgDescription = @"http://218.59.144.96/课程简介：量子理论是描述宇宙的基本理论。20世纪前五十年，普朗克，爱因斯坦，玻尔，海森堡，薛定谔的发现改变了整个物理学。量子力学的新逻辑和新数学完全取代了经典物理。本课中我们会探索光的粒子理论，海森堡不确定原理，还有薛定谔方程";
    
    NSData *thumImageData = UIImageJPEGRepresentation([UIImage imageNamed:@"image_1.png"], 1.f);
    [message setThumbData:thumImageData];
    message.mediaObject = videoObject;
    
    SendMessageToYXReq *req = [[SendMessageToYXReq alloc] init];
    req.bText = NO;
    req.scene = _curScene;
    req.message = message;
    
    [YXApi sendReq:req];
    [req release];
    //    BOOL result = [YXApi sendReq:req];// 返回校验结果
    //    if(!result){
    //        [self showAlert:@"数据校验有误，请重新检查后 分享"];
    //    }
    //    [req release];
}

// 第三方app信息
// 在易信app中 点击分享的内容， 跳转到 第三方app中显示 appExtend
// [url | extInfo | fileData] 参数不能同时为空
- (void)sendAppExtendContent
{
    YXAppExtendObject *extendObject = [YXAppExtendObject object];
    extendObject.url =  @"http://www.yue365.com/play/5194/302634.shtml";
    extendObject.extInfo = @"sdsdsd";
    extendObject.fileData =  nil;
    
    YXMediaMessage *message = [YXMediaMessage message];
    message.title = @"App信息";
    message.msgDescription = @"童鞋，我又想跟你说个事呀！童鞋，童鞋，我又想跟你说个事呀！";
    
    NSData *thumImageData = UIImageJPEGRepresentation([UIImage imageNamed:@"image_2.jpg"], 1.f);
    [message setThumbData:thumImageData];
    message.mediaObject = extendObject;
    
    SendMessageToYXReq *req = [[SendMessageToYXReq alloc] init];
    req.bText = NO;
    req.scene = _curScene;
    req.message = message;
    
    [YXApi sendReq:req];
    [req release];
    //    BOOL result = [YXApi sendReq:req];// 返回校验结果
    //    if(!result){
    //        [self showAlert:@"数据校验有误，请重新检查后 分享"];
    //    }
    //    [req release];
}

- (void)showAlert: (NSString *)msg
{
    if(msg){
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"信息提示" message:msg delegate:nil cancelButtonTitle:@"ok" otherButtonTitles:nil];
        [alert show];
        [alert release];
    }
}

- (void)resetScene:(NSInteger)scene
{
    if (scene == 0) {
        _curScene = kYXSceneSession;
    }else if(scene == 2){
        _curScene = kYXSceneFavorite;
    }else{
        _curScene = kYXSceneTimeline;
    }
}

@end
