//
//  OauthDemoWebViewController.m
//  YixinSDK
//
//  Created by user on 13-11-20.
//  Copyright (c) 2013年 Netease. All rights reserved.
//

#import "OauthDemoWebViewController.h"
#import "OauthTestAppDelegate.h"

#define DELEGATE ((OauthTestAppDelegate *)[[UIApplication sharedApplication] delegate])

@interface OauthDemoWebViewController ()

@end



@implementation OauthDemoWebViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    [self showNavbar];
    
    _webview.delegate = self;
    
    
    [self loadRequest];
}

- (void) showNavbar
{
    //创建一个导航栏集合
    UINavigationItem *navigationItem = [[UINavigationItem alloc] initWithTitle:@""];
    
    //创建一个左边按钮
    UIBarButtonItem *leftButton = [[UIBarButtonItem alloc] initWithTitle:@"取消返回" style:UIBarButtonItemStyleDone target:self action:@selector(goback)];
    
    //创建一个右边按钮
    UIBarButtonItem *rightButton = [[UIBarButtonItem alloc] initWithTitle:@"刷新"
                                                                    style:UIBarButtonItemStyleDone
                                                                   target:self
                                                                   action:@selector(retry)];
    //设置导航栏内容
    [navigationItem setTitle:@"oauth授权"];
    
    
    //把导航栏集合添加入导航栏中，设置动画关闭
    [_nav pushNavigationItem:navigationItem animated:NO];
    
    //把左右两个按钮添加入导航栏集合中
    [navigationItem setLeftBarButtonItem:leftButton];
    [navigationItem setRightBarButtonItem:rightButton];
    
    //释放对象
    [navigationItem release];
    [leftButton release];
    [rightButton release];
}

- (void) loadRequest
{
    NSString *urlStr = [DELEGATE getYixinOAuthReqURIstr];
    NSURL *url = [NSURL URLWithString: urlStr];
    NSURLRequest *request =[NSURLRequest requestWithURL:url];
    [self.webview loadRequest:request];
}

#pragma UIWebViewDelegate

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
	NSURL *tmpUrl = [request URL];
	NSString *requestString = [tmpUrl absoluteString];
    if([DELEGATE isYixinOAuthCallbackURL:requestString]){
        [self goback];
        [DELEGATE parseYixinOAuthCallbackURI:requestString];
        return NO;
    }
    return YES;
}
/*
- (void)webViewDidStartLoad:(UIWebView *)webView
{
    
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
}

- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
    NSLog(error);
}*/
//UIWebViewDelegate end

- (void) goback
{
    [_webview loadHTMLString:@"" baseURL:nil];
    [_webview stopLoading];
    [_webview setDelegate:nil];
    [_webview removeFromSuperview];
    if(self.presentingViewController){
        if([self respondsToSelector:@selector(dismissViewControllerAnimated:completion:)]){
            [self dismissViewControllerAnimated:YES completion:nil];
        }else if([self respondsToSelector:@selector(dismissModalViewControllerAnimated:)]){
            [self dismissViewControllerAnimated:YES completion:nil];
            
        }
    }else{
        [self.navigationController popViewControllerAnimated:YES];
    }
}

- (void) retry
{
    [self loadRequest];
}

- (void)viewDidUnload
{
    _webview.delegate = nil;
    self.webview = nil;
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)dealloc {
    _webview.delegate = nil;
    [_webview release];
    [_nav release];
    [super dealloc];
}
@end
